QGIS Application - Bug report #1856
Improving Show/Hide all layers
2009-08-03 08:21 PM - gcarrillo -

Status: Closed

Priority: Low

Assignee: Magnus Homann

Category: Map Legend

Affected QGIS version: Regression?: No
Operating System: All Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 11916
Description

| think Show/Hide all layers are really slow methods (prove it with 4 or 5 heavy layers). The users can see every layer changing its state
and consuming some time.

It is caused by multiple calls (one for each layer) to updateMapCanvaslLayerSet method (QgsLegend class, selectAll slot). So one solution
for this issue is: Set the state for the QTreeWidgetltems, set the state for the layers and finally call the updateMapCanvasLayerSet
method.

| did this on a python app and get evident results (even faster than QGis :D), but my app is simple, | don't have layer groups or layer files.
| don't understand how to manage them so, please try this in [[QgsLegend]].

If you want | can make a screencast to show the difference.

Here is my Python code:
self.blockSignals( True )
status = Qt.Checked if select else Qt.Unchecked
for i in range( self.topLevelltemCount() ):
self.topLevelltem( i ).setCheckState( 0, status )
self.topLevelltem( i ).canvasLayer.setVisible( select )
self.blockSignals( False )
self.updateLayerSet() # Finally, update the layer set

Associated revisions

Revision d44fe793 - 2009-08-04 02:22 PM - Magnus Homann

Turn off rendering while looping through all layers hinding/showing. Fixes #1856

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@11263 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

Revision 89818278 - 2009-08-04 02:22 PM - Magnus Homann

Turn off rendering while looping through all layers hinding/showing. Fixes #1856

git-svn-id: http://svn.osgeo.org/qgis/trunk@11263 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2009-08-04 12:48 AM - Giovanni Manghi
Hil

homann is working on changes in the legend gui (see #1815), so he may be interested in this ticket and should be able to help.

#2 - 2009-08-04 05:23 AM - Magnus Homann
- Resolution set to fixed
- Status changed from Open to Closed

Fixed in commit:89818278 (SVN r11264). Turned off rendering instead of blocking signals :-)
Thanks for the idea.
